diff -Nur linux-2.6.9-intc1/drivers/input/tslibdev.c linux-2.6.9-intc1-mih1/drivers/input/tslibdev.c
--- linux-2.6.9-intc1/drivers/input/tslibdev.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/drivers/input/tslibdev.c	2005-04-25 17:39:28.000000000 -0400
@@ -0,0 +1,359 @@
+/*
+ *  linux/drivers/input/tslibdev.c
+ *
+ *  Copyright (C) 2002 Russell King
+ *
+ * From tsdev.c:
+ *
+ *  Copyright (c) 2001 "Crazy" james Simmons 
+ *
+ *  Input driver to Touchscreen device driver module.
+ *
+ *  Sponsored by Transvirtual Technology
+ */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or 
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ * 
+ * Should you need to contact me, the author, you can do so either by
+ * e-mail - mail your message to <jsimmons@transvirtual.com>.
+ */
+
+#include <linux/slab.h>
+#include <linux/poll.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/input.h>
+#include <linux/config.h>
+#include <linux/smp_lock.h>
+#include <linux/random.h>
+#include <linux/time.h>
+#include <linux/list.h>
+#include <linux/miscdevice.h>
+
+struct ucb1x00_dev {
+	int		exist;
+	char		name[16];
+	wait_queue_head_t wait;
+	struct list_head list;
+	struct input_handle handle;
+	int		x;
+	int		y;
+	int		pressure;
+};
+
+struct ts_event {
+	u16		pressure;
+	u16		x;
+	u16		y;
+	u16		pad;
+	struct timeval	stamp;
+};
+
+#define TSDEV_BUFFER_SIZE	64
+
+struct ucb1x00_list {
+	struct list_head	list;
+	struct fasync_struct	*fasync;
+	struct ucb1x00_dev	*tsdev;
+	unsigned int		head;
+	unsigned int		tail;
+	struct ts_event		event[TSDEV_BUFFER_SIZE];
+};
+
+static struct input_handler ucb1x00_handler;
+static struct ucb1x00_dev *ucb1x00_dev;
+
+static void ucb1x00_remove(struct ucb1x00_dev *tsdev);
+
+
+static int ucb1x00_fasync(int fd, struct file *file, int on)
+{
+	struct ucb1x00_list *list = file->private_data;
+	int retval;
+
+	retval = fasync_helper(fd, file, on, &list->fasync);
+	return retval < 0 ? retval : 0;
+}
+
+static int ucb1x00_open(struct inode *inode, struct file *file)
+{
+	struct ucb1x00_list *list;
+	int empty;
+
+	if (!ucb1x00_dev || !ucb1x00_dev->exist)
+		return -ENODEV;
+
+	printk(KERN_WARNING
+		"tslibdev: process %s (%d) uses obsolete tslib device\n",
+		current->comm, current->pid);
+
+	list = kmalloc(sizeof(struct ucb1x00_list), GFP_KERNEL);
+	if (!list)
+		return -ENOMEM;
+
+	memset(list, 0, sizeof(struct ucb1x00_list));
+
+	empty = list_empty(&ucb1x00_dev->list);
+
+	list->tsdev = ucb1x00_dev;
+	list_add(&list->list, &list->tsdev->list);
+
+	file->private_data = list;
+
+	if (empty && list->tsdev->exist)
+		input_open_device(&list->tsdev->handle);
+
+	return 0;
+}
+
+static int ucb1x00_release(struct inode *inode, struct file *file)
+{
+	struct ucb1x00_list *list = file->private_data;
+
+	ucb1x00_fasync(-1, file, 0);
+
+	list_del(&list->list);
+
+	ucb1x00_remove(list->tsdev);
+
+	kfree(list);
+
+	return 0;
+}
+
+static ssize_t
+ucb1x00_read(struct file *file, char *buffer, size_t count, loff_t * ppos)
+{
+	DECLARE_WAITQUEUE(wait, current);
+	struct ucb1x00_list *list = file->private_data;
+	int retval = 0;
+
+	if (list->head == list->tail) {
+		add_wait_queue(&list->tsdev->wait, &wait);
+
+		while (list->head == list->tail) {
+			set_current_state(TASK_INTERRUPTIBLE);
+
+			if (!list->tsdev->exist) {
+				retval = -ENODEV;
+				break;
+			}
+			if (file->f_flags & O_NONBLOCK) {
+				retval = -EAGAIN;
+				break;
+			}
+			if (signal_pending(current)) {
+				retval = -ERESTARTSYS;
+				break;
+			}
+			schedule();
+		}
+		set_current_state(TASK_RUNNING);
+		remove_wait_queue(&list->tsdev->wait, &wait);
+	}
+
+	if (retval)
+		return retval;
+
+	while (list->head != list->tail && count >= sizeof(struct ts_event)) {
+		if (copy_to_user(buffer, list->event + list->tail,
+				 sizeof(struct ts_event)))
+			return retval ? retval : -EFAULT;
+		list->tail = (list->tail + 1) & (TSDEV_BUFFER_SIZE - 1);
+		retval += sizeof(struct ts_event);
+		buffer += sizeof(struct ts_event);
+		count -= sizeof(struct ts_event);
+	}
+	return retval;
+}
+
+/* No kernel lock - fine */
+static unsigned int ucb1x00_poll(struct file *file, poll_table * wait)
+{
+	struct ucb1x00_list *list = file->private_data;
+
+	poll_wait(file, &list->tsdev->wait, wait);
+	if (list->head != list->tail || !list->tsdev->exist)
+		return POLLIN | POLLRDNORM;
+	return 0;
+}
+
+static int
+ucb1x00_ioctl(struct inode *inode, struct file *file, unsigned int cmd,
+	    unsigned long arg)
+{
+	return -EINVAL;
+}
+
+struct file_operations ucb1x00_fops = {
+	.owner		= THIS_MODULE,
+	.open		= ucb1x00_open,
+	.release	= ucb1x00_release,
+	.read		= ucb1x00_read,
+	.poll		= ucb1x00_poll,
+	.fasync		= ucb1x00_fasync,
+	.ioctl		= ucb1x00_ioctl,
+};
+
+/*
+ * The official UCB1x00 touchscreen is a miscdevice:
+ *   10 char        Non-serial mice, misc features
+ *                   14 = /dev/touchscreen/ucb1x00  UCB 1x00 touchscreen
+ */
+static struct miscdevice ucb1x00_ts_dev = {
+	.minor		= 14,
+	.name		= "touchscreen/ucb1x00",
+	.fops		= &ucb1x00_fops,
+	.devfs_name	= "touchscreen/ucb1x00",
+};
+
+static void ucb1x00_remove(struct ucb1x00_dev *tsdev)
+{
+	if (list_empty(&tsdev->list)) {
+		if (tsdev->exist) {
+			input_close_device(&tsdev->handle);
+			wake_up_interruptible(&tsdev->wait);
+		} else {
+			misc_deregister(&ucb1x00_ts_dev);
+			ucb1x00_dev = NULL;
+			kfree(tsdev);
+		}
+	}
+}
+
+
+static void
+ucb1x00_event(struct input_handle *handle, unsigned int type, unsigned int code,
+	    int value)
+{
+	struct ucb1x00_dev *tsdev = handle->private;
+	struct list_head *l;
+
+	/* sorry, we only handle absolute stuff */
+	if (type == EV_ABS) {
+		switch (code) {
+		case ABS_X:
+			tsdev->x = value;
+			break;
+		case ABS_Y:
+			tsdev->y = value;
+			break;
+		case ABS_PRESSURE:
+			tsdev->pressure = value;
+			break;
+		}
+		return;
+	}
+
+	if (type != EV_SYN || code != SYN_REPORT)
+		return;
+
+	list_for_each(l, &tsdev->list) {
+		struct ucb1x00_list *list = list_entry(l, struct ucb1x00_list, list);
+		list->event[list->head].pressure = tsdev->pressure;
+		if (tsdev->pressure) {
+			list->event[list->head].x = tsdev->x;
+			list->event[list->head].y = tsdev->y;
+		} else {
+			list->event[list->head].x = 0;
+			list->event[list->head].y = 0;
+		}
+		do_gettimeofday(&list->event[list->head].stamp);
+		list->head = (list->head + 1) & (TSDEV_BUFFER_SIZE - 1);
+		kill_fasync(&list->fasync, SIGIO, POLL_IN);
+	}
+	wake_up_interruptible(&tsdev->wait);
+}
+
+static struct input_handle *
+ucb1x00_connect(struct input_handler *handler, struct input_dev *dev,
+	      struct input_device_id *id)
+{
+	struct ucb1x00_dev *tsdev;
+
+	if (ucb1x00_dev)
+		return NULL;
+
+	tsdev = kmalloc(sizeof(struct ucb1x00_dev), GFP_KERNEL);
+	if (!tsdev)
+		return NULL;
+
+	memset(tsdev, 0, sizeof(struct ucb1x00_dev));
+	init_waitqueue_head(&tsdev->wait);
+	INIT_LIST_HEAD(&tsdev->list);
+
+	ucb1x00_dev = tsdev;
+
+	strncpy(tsdev->name, "ucb1x00-ts", sizeof(tsdev->name));
+	//strncpy(tsdev->name, "wm97xx-ts", sizeof(tsdev->name));
+
+	tsdev->handle.dev     = dev;
+	tsdev->handle.name    = tsdev->name;
+	tsdev->handle.handler = handler;
+	tsdev->handle.private = tsdev;
+
+	misc_register(&ucb1x00_ts_dev);
+
+	tsdev->exist = 1;
+
+	return &tsdev->handle;
+}
+
+static void ucb1x00_disconnect(struct input_handle *handle)
+{
+	struct ucb1x00_dev *tsdev = handle->private;
+
+	tsdev->exist = 0;
+	ucb1x00_remove(tsdev);
+}
+
+static struct input_device_id ucb1x00_ids[] = {
+	{
+	      .flags	= INPUT_DEVICE_ID_MATCH_ABSBIT,
+	      .evbit	= { BIT(EV_ABS) },
+	      .absbit	= { BIT(ABS_X) | BIT(ABS_Y) | BIT(ABS_PRESSURE) },
+	},
+
+	{},/* Terminating entry */
+};
+
+MODULE_DEVICE_TABLE(input, ucb1x00_ids);
+
+static struct input_handler ucb1x00_handler = {
+	.event		= ucb1x00_event,
+	.connect	= ucb1x00_connect,
+	.disconnect	= ucb1x00_disconnect,
+	.name		= "touchscreen/ucb1x00",
+	.id_table	= ucb1x00_ids,
+};
+
+static int __init ucb1x00_init(void)
+{
+	input_register_handler(&ucb1x00_handler);
+	printk(KERN_INFO "ts: UCB1x00 touchscreen protocol output\n");
+	return 0;
+}
+
+static void __exit ucb1x00_exit(void)
+{
+	input_unregister_handler(&ucb1x00_handler);
+}
+
+module_init(ucb1x00_init);
+module_exit(ucb1x00_exit);
+
+MODULE_AUTHOR("Russell King <rmk@arm.linux.org.uk>");
+MODULE_DESCRIPTION("Input driver to UCB1x00 touchscreen converter");
diff -Nur linux-2.6.9-intc1/drivers/misc/glencoe_periph.c linux-2.6.9-intc1-mih1/drivers/misc/glencoe_periph.c
--- linux-2.6.9-intc1/drivers/misc/glencoe_periph.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/drivers/misc/glencoe_periph.c	2005-05-03 14:39:27.000000000 -0400
@@ -0,0 +1,284 @@
+/*
+ * glencoe_periph.c: adds entries to /proc fs to provide manual 
+ * access&control to peripherals on Glencoe (LEDs, LCD backlight,
+ * card detection, ...)
+ * 
+ * - write 1 to assert, 0 to de-assert pins
+ *
+ *  Copyright (c) 2005 Matthias Ihmig <m.ihmig@mytum.de>
+ *
+ * This program is free software; you can redistribute
+ * it and/or modify it under the terms of the GNU General
+ * Public License as published by the Free Software
+ * Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ *
+ * This program is distributed in the hope that it will be
+ * useful, but WITHOUT ANY WARRANTY; without even the implied
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ * PURPOSE.  See the GNU General Public License for more
+ * details.
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/proc_fs.h>
+#include <linux/delay.h>
+#include <asm/uaccess.h>
+
+#include <asm/hardware.h>
+#include <asm/arch/pxa-regs.h>
+#include <asm/arch/glencoe.h>
+
+#define MODULE_VERS "1.0"
+#define MODULE_NAME "glencoe_periph"
+
+static struct proc_dir_entry *gem_dir, *gpio0, *usim, *mmc, *cf1, *cf2, *green, *blue, *bl, *lcd, *lcd_pwm;
+
+static int proc_read_gpio(char *page, char **start, off_t off, int count,
+			     int *eof, void *data)
+{
+	return sprintf(page, "%s\n", (GPIO_lev( (int)data) ? "1" : "0")); // active high signal
+}
+static int proc_read_ngpio(char *page, char **start, off_t off, int count,
+			     int *eof, void *data)
+{
+	return sprintf(page, "%s\n", (GPIO_lev( (int)data) ? "0" : "1")); // active low signal -> invert
+}
+
+static int proc_write_gpio(struct file *file, const char *buffer,
+			     unsigned long count, void *data)
+{
+	int len=0;
+	char value='0';
+
+	if(count >= 1)
+		len = 1;
+	else
+		return -EFAULT;
+
+	if(copy_from_user(&value, buffer, len))
+		return -EFAULT;
+
+	if (value == '1')
+		GPIO_set( (int)data );		// assert pin (active high)
+	if (value == '0')
+		GPIO_clr( (int)data );		// deassert pin
+	return len;
+}
+static int proc_write_ngpio(struct file *file, const char *buffer,
+			     unsigned long count, void *data)
+{
+	int len=0;
+	char value='0';
+
+	if(count >= 1)
+		len = 1;
+	else
+		return -EFAULT;
+
+	if(copy_from_user(&value, buffer, len))
+		return -EFAULT;
+
+	if (value == '1')
+		GPIO_clr( (int)data );		// assert pin (active low)
+	if (value == '0')
+		GPIO_set( (int)data );		// deassert pin
+	return len;
+}
+
+static int proc_read_pwm(char *page, char **start, off_t off, int count,
+			     int *eof, void *data)
+{
+	return sprintf(page, "current:%d max:%d\n", GLN_BACKLIGHT_PWM_PWDUTY, GLN_BACKLIGHT_PWM_PERVAL);
+}
+
+static int proc_write_pwm(struct file *file, const char *buffer,
+			     unsigned long count, void *data)
+{
+	int len=count, width;
+	char value[10];
+
+	if(count > 9)
+		len = 9;
+	else
+		len = count;
+
+	if(copy_from_user(&value, buffer, len))
+		return -EFAULT;
+	
+	if (sscanf(value, "%d", &width) != 1)
+		return -EINVAL;
+
+	if ( (width >= 0) && (width <= GLN_BACKLIGHT_PWM_PERVAL) ) {
+		pxa_set_cken(GLN_BACKLIGHT_PWM_CKEN, 1);
+		GLN_BACKLIGHT_PWM_CTRL = 0;
+		GLN_BACKLIGHT_PWM_PWDUTY = width;
+		GLN_BACKLIGHT_PWM_PERVAL = 0x3ff;
+	}
+	return len;
+}
+
+static int __init init_glencoe_periph(void)
+{
+	int rv = 0;
+	
+	// Initialize GPIO registers
+	pxa_gpio_mode(GLN_GPIO_GPIO0         | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_nUSIM_CD_CPU  | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_nMMC_CARD_DET | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_nGREEN_LED    | GPIO_OUT);
+	pxa_gpio_mode(GLN_GPIO_nBLUE_LED     | GPIO_OUT);
+	pxa_gpio_mode(GLN_GPIO_BL_PWR_ON     | GPIO_OUT);
+	pxa_gpio_mode(GLN_GPIO_LCD_PWR_ON    | GPIO_OUT);
+	pxa_gpio_mode(GLN_GPIO_nCF1_CARD_DET | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_nCF2_CARD_DET | GPIO_IN);
+	pxa_gpio_mode(GLN_BACKLIGHT_PWM_MD);
+
+	/* create directory */
+	gem_dir = proc_mkdir("driver/" MODULE_NAME, NULL);
+	if(gem_dir == NULL) {
+		rv = -ENOMEM; goto out;
+	}
+	gem_dir->owner = THIS_MODULE;
+	
+	// input files
+	gpio0 = create_proc_read_entry("gpio0_state", 0444, gem_dir, proc_read_gpio, (void*)GLN_GPIO_GPIO0);
+	if(gpio0 == NULL) {
+		rv  = -ENOMEM; goto no_gpio0;
+	}
+	gpio0->owner = THIS_MODULE;
+
+	usim = create_proc_read_entry("sim_inserted", 0444, gem_dir, proc_read_ngpio, (void*)GLN_GPIO_nUSIM_CD_CPU);
+	if(usim == NULL) {
+		rv  = -ENOMEM; goto no_usim;
+	}
+	usim->owner = THIS_MODULE;
+	
+	mmc = create_proc_read_entry("mmc_inserted", 0444, gem_dir, proc_read_ngpio, (void*)GLN_GPIO_nMMC_CARD_DET);
+	if(mmc == NULL) {
+		rv  = -ENOMEM; goto no_mmc;
+	}
+	mmc->owner = THIS_MODULE;
+
+	cf1 = create_proc_read_entry("cf1_inserted", 0444, gem_dir, proc_read_ngpio, (void*)GLN_GPIO_nCF1_CARD_DET);
+	if(cf1 == NULL) {
+		rv  = -ENOMEM; goto no_cf1;
+	}
+	cf1->owner = THIS_MODULE;
+
+	cf2 = create_proc_read_entry("cf2_inserted", 0444, gem_dir, proc_read_ngpio, (void*)GLN_GPIO_nCF2_CARD_DET);
+	if(cf2 == NULL) {
+		rv  = -ENOMEM; goto no_cf2;
+	}
+	cf2->owner = THIS_MODULE;
+
+
+	// output files
+	green = create_proc_entry("green_led_on", 0644, gem_dir);
+	if(green == NULL) {
+		rv = -ENOMEM;
+		goto no_green;
+	}
+	green->data = (void*)GLN_GPIO_nGREEN_LED;
+	green->read_proc = proc_read_ngpio;
+	green->write_proc = proc_write_ngpio;
+	green->owner = THIS_MODULE;
+	
+	blue = create_proc_entry("blue_led_on", 0644, gem_dir);
+	if(blue == NULL) {
+		rv = -ENOMEM;
+		goto no_blue;
+	}
+	blue->data = (void*)GLN_GPIO_nBLUE_LED;
+	blue->read_proc = proc_read_ngpio;
+	blue->write_proc = proc_write_ngpio;
+	blue->owner = THIS_MODULE;
+		
+	bl = create_proc_entry("backlight_on", 0644, gem_dir);
+	if(bl == NULL) {
+		rv = -ENOMEM;
+		goto no_bl;
+	}
+	bl->data = (void*)GLN_GPIO_BL_PWR_ON;
+	bl->read_proc = proc_read_gpio;
+	bl->write_proc = proc_write_gpio;
+	bl->owner = THIS_MODULE;
+	
+	lcd = create_proc_entry("lcd_on", 0644, gem_dir);
+	if(lcd == NULL) {
+		rv = -ENOMEM;
+		goto no_lcd;
+	}
+	lcd->data = (void*)GLN_GPIO_LCD_PWR_ON;
+	lcd->read_proc = proc_read_gpio;
+	lcd->write_proc = proc_write_gpio;
+	lcd->owner = THIS_MODULE;
+
+	lcd_pwm = create_proc_entry("lcd_pwm", 0644, gem_dir);
+	if(lcd_pwm == NULL) {
+		rv = -ENOMEM;
+		goto no_lcd_pwm;
+	}
+	lcd_pwm->data = NULL;
+	lcd_pwm->read_proc = proc_read_pwm;
+	lcd_pwm->write_proc = proc_write_pwm;
+	lcd_pwm->owner = THIS_MODULE;
+
+
+	/* everything OK */
+	printk(KERN_INFO "%s %s proc interface initialised\n",
+	       MODULE_NAME, MODULE_VERS);
+	return 0;
+
+no_lcd_pwm:
+	remove_proc_entry("lcd_on", gem_dir);
+no_lcd:
+	remove_proc_entry("backlight_on", gem_dir);
+no_bl:
+	remove_proc_entry("blue_led_on", gem_dir);
+no_blue:
+	remove_proc_entry("green_led_on", gem_dir);
+no_green:
+
+	remove_proc_entry("cf2_inserted", gem_dir);
+no_cf2:
+	remove_proc_entry("cf1_inserted", gem_dir);
+no_cf1:
+	remove_proc_entry("mmc_inserted", gem_dir);
+no_mmc:
+	remove_proc_entry("sim_inserted", gem_dir);
+no_usim:
+	remove_proc_entry("gpio0_state", gem_dir);
+no_gpio0:
+	remove_proc_entry(MODULE_NAME, NULL);
+out:
+	return rv;
+}
+
+static void __exit cleanup_glencoe_periph(void)
+{
+	remove_proc_entry("lcd_pwm", gem_dir);
+	remove_proc_entry("lcd_on", gem_dir);
+	remove_proc_entry("backlight_on", gem_dir);
+	remove_proc_entry("blue_led_on", gem_dir);
+	remove_proc_entry("green_led_on", gem_dir);
+	remove_proc_entry("cf2_inserted", gem_dir);
+	remove_proc_entry("cf1_inserted", gem_dir);
+	remove_proc_entry("mmc_inserted", gem_dir);
+	remove_proc_entry("sim_inserted", gem_dir);
+	remove_proc_entry("gpio0_state", gem_dir);
+	remove_proc_entry(MODULE_NAME, NULL);
+
+	printk(KERN_INFO "%s %s interface removed\n",
+	       MODULE_NAME, MODULE_VERS);
+}
+
+module_init(init_glencoe_periph);
+module_exit(cleanup_glencoe_periph);
+
+MODULE_AUTHOR("Matthias Ihmig <m.ihmig@mytum.de>");
+MODULE_DESCRIPTION("Glencoe GPIO peripherals /proc interface");
+MODULE_LICENSE("GPL");
+
diff -Nur linux-2.6.9-intc1/drivers/misc/Kconfig linux-2.6.9-intc1-mih1/drivers/misc/Kconfig
--- linux-2.6.9-intc1/drivers/misc/Kconfig	2004-10-18 17:53:43.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/misc/Kconfig	2005-05-03 14:38:17.000000000 -0400
@@ -29,5 +29,106 @@
 
 	  If unsure, say N.
 
+config XIRCOM_GEM
+	tristate "Xircom GEM Module support"
+	depends on ARCH_PXA
+	---help---
+	  Say Y here if you have an Intel GEM GSM/GPRS module connected to your
+	  PXA GPIOs and want to control it through the /proc/sys interface.
+	  
+	  Examples:
+	  Power down: $ echo 1 > /proc/driver/xircom_gem/power_down
+	  Wake up:    $ echo 1 > /proc/driver/xircom_gem/wake_up
+	  Reset:      $ echo 1 > /proc/driver/xircom_gem/reset
+	  
+	  Get sleep status:  $ cat /proc/driver/xircom_gem/asleep
+
+config GLENCOE_PERIPH
+	tristate "Intel Glencoe board manual /proc interface to control peripherals"
+	depends on ARCH_PXA
+	---help---
+	  Say Y here if you want to access and control Glencoe through the /proc/sys interface. This includes LEDs, LCD and SIM/MMC/CompactFlash card detection
+	  
+	  Examples:
+	  Input (query state, returns 1 when asserted):
+	  $ cat /proc/driver/glencoe_periph/gpio0_state
+	  $ cat /proc/driver/glencoe_periph/sim_inserted
+	  $ cat /proc/driver/glencoe_periph/mmc_inserted
+	  $ cat /proc/driver/glencoe_periph/cf1_inserted
+	  $ cat /proc/driver/glencoe_periph/cf2_inserted
+
+	  Output (set state):
+	  $ echo 1 > /proc/driver/glencoe_periph/green_led_on
+	  $ echo 1 > /proc/driver/glencoe_periph/blue_led_on
+	  $ echo 1 > /proc/driver/glencoe_periph/backlight_on
+	  $ echo 1 > /proc/driver/glencoe_periph/lcd_on
+
+	  Set LCD backlight brightness (value between 0-1023):
+	  $ echo 300 > /proc/driver/glencoe_periph/lcd_pwm
+	  
+	  Please note that setting the LEDs only works when the Timer and CPU LEDs
+	  are deactivated (disable General setup->Timer and CPU usage LEDs)
+
 endmenu
 
+menu "Multimedia Capabilities Port drivers"
+
+config MCP
+	tristate "MCP layer"
+
+# Interface drivers
+config MCP_SA1100
+	tristate "Support SA1100 MCP interface"
+	depends on ARCH_SA1100
+	select MCP
+
+# Chip drivers
+config MCP_UCB1200
+	tristate "Support for UCB1200 / UCB1300"
+	depends on MCP
+
+config MCP_UCB1200_AUDIO
+	tristate "Audio / Telephony interface support"
+	depends on MCP_UCB1200 && SOUND
+
+config MCP_UCB1200_TS
+	tristate "Touchscreen interface support"
+	depends on MCP_UCB1200 && INPUT
+
+config UCB1400_TS
+	tristate "UCB1400 Touchscreen support"
+	depends on ARCH_PXA
+
+config MCP_WM97XX
+	tristate "Support for WM97xx MCP interface"
+	depends on SND_AC97_CODEC
+
+config MCP_WM9713_TS
+	tristate "WM9713 Touchscreen interface support"
+	depends on MCP_WM97XX && INPUT 
+	help
+	  Say Y here if you have the wm9713 touchscreen.
+
+	  If unsure, say N.
+
+	  To compile this driver as a module, choose M here: the
+	  module will be called wm9713-ts.
+	
+config MCP_WM9705_TS
+	tristate "WM9705/12 Touchscreen interface support"
+	depends on MCP_WM97XX && INPUT 
+	help
+	  Say Y here if you have the wm9705/12 touchscreen.
+
+	  If unsure, say N.
+
+	  To compile this driver as a module, choose M here: the
+	  module will be called wm9705-ts.
+	  
+config MCP_WM97XX_PXA
+	tristate "WM97xx PXA accelerated touch"
+	depends on MCP_WM97XX && ARCH_PXA
+	help
+	  Say Y here for continuous mode touch on the PXA
+
+endmenu
diff -Nur linux-2.6.9-intc1/drivers/misc/Makefile linux-2.6.9-intc1-mih1/drivers/misc/Makefile
--- linux-2.6.9-intc1/drivers/misc/Makefile	2004-10-18 17:55:24.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/misc/Makefile	2005-04-22 02:35:45.000000000 -0400
@@ -4,3 +4,22 @@
 obj- := misc.o	# Dummy rule to force built-in.o to be made
 
 obj-$(CONFIG_IBM_ASM)	+= ibmasm/
+obj-$(CONFIG_XIRCOM_GEM) += xircom_gem.o
+obj-$(CONFIG_GLENCOE_PERIPH) += glencoe_periph.o
+
+obj-$(CONFIG_MCP)		+= mcp-core.o
+obj-$(CONFIG_MCP_UCB1200)	+= ucb1x00-core.o
+obj-$(CONFIG_MCP_UCB1200_AUDIO)	+= ucb1x00-audio.o
+obj-$(CONFIG_MCP_UCB1200_TS)	+= ucb1x00-ts.o
+obj-$(CONFIG_MCP_WM97XX)       += wm97xx-core.o mcp-ac97.o
+obj-$(CONFIG_MCP_WM9713_TS)    += wm9713-ts.o
+obj-$(CONFIG_MCP_WM9705_TS)    += wm9705-ts.o
+obj-$(CONFIG_MCP_WM97XX_PXA)   += pxa-wm97xx-touch.o
+
+ifeq ($(CONFIG_SA1100_ASSABET),y)
+obj-$(CONFIG_MCP_UCB1200)	+= ucb1x00-assabet.o
+endif
+
+obj-$(CONFIG_MCP_SA1100)	+= mcp-sa1100.o
+ucb1400-core-y			:= ucb1x00-core.o mcp-ac97.o
+obj-$(CONFIG_UCB1400_TS)	+= ucb1400-core.o ucb1x00-ts.o
diff -Nur linux-2.6.9-intc1/drivers/misc/mcp-ac97.c linux-2.6.9-intc1-mih1/drivers/misc/mcp-ac97.c
--- linux-2.6.9-intc1/drivers/misc/mcp-ac97.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/drivers/misc/mcp-ac97.c	2005-05-02 17:40:07.000000000 -0400
@@ -0,0 +1,148 @@
+/*
+ * linux/drivers/misc/mcp-ac97.c
+ *
+ * Author:	Nicolas Pitre
+ * Created:	Jan 14, 2005
+ * Copyright:	(C) MontaVista Software Inc.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * version 2 as published by the Free Software Foundation.
+ *
+ * This module provides the minimum replacement for mcp-core.c allowing for
+ * the UCB1400 chip to be driven by the ucb1x00 driver over an AC97 link.
+ */
+
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/errno.h>
+#include <linux/device.h>
+#include <linux/config.h>
+
+#include <sound/driver.h>
+#include <sound/core.h>
+#include <sound/ac97_codec.h>
+
+#include "mcp.h"
+
+
+unsigned int mcp_reg_read(struct mcp *mcp, unsigned int reg)
+{
+	ac97_t *ac97 = mcp->me->platform_data;
+	return ac97->bus->ops->read(ac97, reg);
+}
+
+void mcp_reg_write(struct mcp *mcp, unsigned int reg, unsigned int val)
+{
+	ac97_t *ac97 = mcp->me->platform_data;
+	ac97->bus->ops->write(ac97, reg, val);
+}
+
+void mcp_enable(struct mcp *mcp)
+{
+}
+
+void mcp_disable(struct mcp *mcp)
+{
+}
+
+#define to_mcp_driver(d)	container_of(d, struct mcp_driver, drv)
+
+static int mcp_probe(struct device *dev)
+{
+	struct mcp_driver *drv = to_mcp_driver(dev->driver);
+	struct mcp *mcp;
+	int ret;
+
+	printk("mcp_probe: probing..\n");
+
+	ret = -ENOMEM;
+	mcp = kmalloc(sizeof(*mcp), GFP_KERNEL);
+	if (mcp) {
+		memset(mcp, 0, sizeof(*mcp));
+		mcp->owner = THIS_MODULE;
+		mcp->reg_read = mcp_reg_read;
+		mcp->reg_write = mcp_reg_write;
+		mcp->enable = mcp_enable;
+		mcp->disable = mcp_disable;
+		mcp->me = dev;
+		mcp->attached_device = dev;
+
+		ret = drv->probe(mcp);
+		printk("mcp_probe: drv->probe called..\n");
+		if (ret)
+			kfree(mcp);
+	}
+	return ret;
+}
+
+static int mcp_remove(struct device *dev)
+{
+	struct mcp_driver *drv = to_mcp_driver(dev->driver);
+	struct mcp *mcp = *(struct mcp **)dev_get_drvdata(dev);
+
+	drv->remove(mcp);
+	kfree(mcp);
+	return 0;
+}
+
+static int mcp_suspend(struct device *dev, u32 state, u32 level)
+{
+	struct mcp_driver *drv = to_mcp_driver(dev->driver);
+	struct mcp *mcp = dev_get_drvdata(dev);
+	int ret = 0;
+
+	if (drv->suspend && level == SUSPEND_DISABLE)
+		ret = drv->suspend(mcp, state);
+	return ret;
+}
+
+static int mcp_resume(struct device *dev, u32 level)
+{
+	struct mcp_driver *drv = to_mcp_driver(dev->driver);
+	struct mcp *mcp = dev_get_drvdata(dev);
+	int ret = 0;
+
+	if (drv->resume && level == RESUME_ENABLE)
+		ret = drv->resume(mcp);
+	return ret;
+}
+
+int mcp_driver_register(struct mcp_driver *mcpdrv)
+{
+/*
+#if defined( CONFIG_MCP_WM9713_TS )    || defined( CONFIG_MCP_WM9713_TS_MODULE )
+	mcpdrv->drv.name = "WM9713";
+#elif defined( CONFIG_MCP_WM9705_TS ) || defined( CONFIG_MCP_WM9705_TS_MODULE )
+	mcpdrv->drv.name = "WM97xx";
+#elif defined( CONFIG_UCB1400_TS )    || defined( CONFIG_UCB1400_TS_MODULE )
+	mcpdrv->drv.name = "UCB1400";
+#else
+	#warning "Using default Touchpad driver: WM9713"
+	mcpdrv->drv.name = "WM9713";
+#endif
+*/
+	mcpdrv->drv.name = "WM9713";
+	printk("mcp_driver_register: called\n");
+
+	mcpdrv->drv.bus = &ac97_bus_type;
+	mcpdrv->drv.probe = mcp_probe;
+	mcpdrv->drv.remove = mcp_remove;
+	mcpdrv->drv.suspend = mcp_suspend;
+	mcpdrv->drv.resume = mcp_resume;
+	return driver_register(&mcpdrv->drv);
+}
+
+void mcp_driver_unregister(struct mcp_driver *mcpdrv)
+{
+	driver_unregister(&mcpdrv->drv);
+}
+
+EXPORT_SYMBOL(mcp_reg_read);
+EXPORT_SYMBOL(mcp_reg_write);
+EXPORT_SYMBOL(mcp_enable);
+EXPORT_SYMBOL(mcp_disable);
+EXPORT_SYMBOL(mcp_driver_register);
+EXPORT_SYMBOL(mcp_driver_unregister);
+
+MODULE_LICENSE("GPL");
